package jp.agentec.sinaburocast.form.admin.enquete;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.builder.StandardToStringStyle;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.velocity.tools.generic.ListTool;
import org.mobylet.core.util.StringUtils;
import org.seasar.framework.util.StringUtil;

import jp.agentec.sinaburocast.common.SinaburoConstant;
import jp.agentec.sinaburocast.common.util.PropertyUtil;
import jp.agentec.sinaburocast.common.util.SinaburoUtil;
import jp.agentec.sinaburocast.entity.Answer;
import jp.agentec.sinaburocast.entity.Enquete;
import jp.agentec.sinaburocast.entity.Organization;
import jp.agentec.sinaburocast.entity.Question;
import jp.agentec.sinaburocast.service.QuestionService;



/**
 * アンケート登録Form
 *
 * @author choi-c
 *
 */
//@Component(instance=InstanceType.SESSION)
public class EnqueteRegistForm {

	public QuestionService questionService;

	/**
	 * コマンド:copy=コーピーを押下した場合
	 */
	public String cmd;

	/**
	 * 画面入力用
	 */
	public Enquete enquete;

	/**
	 * アンケートID
	 */
	public String eid;

	/**
	 * 設問ID
	 */
	public String qid;

	/**
	 * アンケートの回答件数
	 */
	public Long replyCount;
	/**
	 * 削除設問ID
	 * */
	public String delQuestionIdList;

	/**
	 * 設問一覧の順番変更
	 */
	public ArrayList<String> questionNoSort;

	/**
	 * 設問一覧の順番変更<最初>
	 */
	public ArrayList<String> questionNoSortOld;


	/**
	 * 画面表示用「設問一覧」、設問定義では条件付き必須項目用
	 */
	public ArrayList<Question> questionList;

	/**
	 * 画面入・出用「設問定義」
	 */
	public Question inputQuestion = new Question();


//	/**
//	 * 設問一覧から設問内容をクリックした場合更新。
//	 */
//	public String updateFlg;
	/**設問一覧画面から押下された設問ID*/
//	public Integer questionIdLink;

	/**quesiton番号ををして遷移した場合1 新規の場合は0 ※修正の場合*/
//	public String clickQuestion;




	public static final String sessionKey="admin_enquete_enqueteRegistForm";

	//条件付き必須の回答一覧[表示用]
	public ArrayList<Answer> condRequiredQuestionAnswerList;

	//1%支援制度ポイント寄付「select画面表示用」
	public List<Organization> organizationListFor1Percent;

	//条件付き必須の回答一覧[入力用]
	public ArrayList<String> condRequiredAnswerIdList;

	/**ラジオボタン関連*/
	//表示列項目数
	public Integer radioColumnCount;
	//デフォルト
	public String radioDefault;
	//管理用文字列
	public ArrayList<String> radioAdminText;
	/*//表示用文字列
	public String [] radioDispText;*/
	//自由入力欄該当カウント
	public String radioFreeNo;
	//自由入力使用可否 1使用、0未使用
	public String radioFreeAnserUse;
	//自由入力欄該当選択番号
	public String freeRadioNo;
	//自由入力必須 1必須、0未必須
	public String radioFreeAnserRequired;
	//ラジを自由入力欄幅
	public String radioFreeTextColWidth;
	//ラジを自由入力最大
	public String radioFreeTextLimit;
	//チェックされたラジオ行番号
	public String checkedVal;

	/**チェックボックス関連*/
	//最大選択数
	public String checkMaxSelectNum;
	//デフォルト
	public ArrayList<String> checkDefault;
	//最小選択数
	public String checkMinSelectNum;
	//表示列項目数
	public Integer checkColumnCount;
	//管理用文字列
	public ArrayList<String> checkAdminText;
	/*//表示用文字列
	public String [] checkDispText;*/
	//自由入力使用可否 1使用、0未使用
	public String checkFreeAnserUse;
	//自由入力欄該当選択番号
	public String checkFreeNo;
	//自由入力欄必須
	public String checkFreeAnserRequired;
	//自由入力欄幅
	public String checkFreeTextColWidth;
	//自由入力欄幅
	public String checkFreeTextLimit;

	/**セレクトメニュー関連*/
	//空白追加
	public String selectKuhakuUse;
	//選択候補
	public String selectCand;
	//選択候補
	public String selectDefault;

	/**テキストボックス関連*/
	//表示幅(文字数)
	public String textSize;
	//最小入力文字数
	public String textMinLength;
	//最小入力文字数
	public String textMaxLength;
	//入力文字制限
	//["なし","半角数字のみ","半角英数字のみ","全角カナのみ","全角のみ","郵便番号","電話番号","メールアドレス"] )
    //    0         1               2                 3          4          5          6             7
	public String textSeigen;
	//送信用メールアドレス
	public String isSendMailAddress;

	/**テキストエリア関連*/
	//列幅(文字数)
	public String areaCols;
	//行数
	public String areaRows;
	//最大入力文字数
	public String areaMaxCount;

	/**日付関連*/
	//開始日
	public String dateFrom;
	//終了日
	public String dateTo;

	/**1%支援制度ポイント寄付*/
	//市民団体
	public String percentOrganizationId;

	/**回答文字列ID 設問編集の場合のみ使用*/
	public ArrayList<String> radioAsnwerIdList;
	public ArrayList<String> checkAsnwerIdList;
	public ArrayList<String> selectAsnwerIdList;

	//市民団体デフォルト
//	public String percentDefaultOrganizationId;


	public void resetIndex(){
		eid = "0";
		enquete = null;
	}


	public String x;
	public String y;



	public ActionMessages questionEditValidate(){
		ActionMessages errors = new ActionMessages();

		String regex = SinaburoConstant.Regex.INT_STRING;


		/**コントロール以外のチェック*/
		if(StringUtil.isBlank(inputQuestion.questionName)){
			errors.add("inputQuestion_questionName", new ActionMessage("labels.questionName"/*"設問内容を入力してください。"*/));
		}

		if(inputQuestion.condRequiredQuestionNo != null && !new Integer(0).equals(inputQuestion.condRequiredQuestionNo) && inputQuestion.requiredFlg == 1){
			errors.add("inputQuestion_condRequiredQuestionNo", new ActionMessage("errors.E059"));
		}
		
		if(inputQuestion.condRequiredQuestionNo != null && !new Integer(0).equals(inputQuestion.condRequiredQuestionNo) && (CollectionUtils.isEmpty(condRequiredAnswerIdList) || StringUtil.equals(condRequiredAnswerIdList.get(0) ,"0"))){
			errors.add("inputQuestion_condRequiredQuestionNo", new ActionMessage("errors.E047"/*"条件付必須項目を選択した場合は条件付必須回答を選択してください。"*/));
		}
		
		switch (inputQuestion.controlId) {
		case 0:
			/**ラジオボタン*/
			int j=0;
			for(j=0;j<radioAdminText.size();j++){
				if(StringUtil.isBlank(radioAdminText.get(j))){
					errors.add("radioAdminText"+j, new ActionMessage("labels.answer"/*"回答文字列を入力してください。"*/));
				}
			}

			if(StringUtil.equals(radioFreeAnserUse, "1") && Integer.parseInt(radioFreeNo) > j  ){
				errors.add("radioFreeNoError", new ActionMessage("labels.freeMax","該当選択肢"/*"最大選択数は選択肢の数以下にしてください。"*/));
			}

			break;
		case 1:
			/**チェックボックス*/
			int i=0;
			for(i=0;i<checkAdminText.size();i++){
				if(StringUtil.isBlank(checkAdminText.get(i))){
					errors.add("checkAdminText"+i, new ActionMessage("labels.answer"));
				}
			}

			if( Integer.parseInt(checkMaxSelectNum) > (i)){
				errors.add("checkAdminText"+(i-1), new ActionMessage("labels.checkMax"/*"最大選択数は選択肢の数以下にしてください。"*/));
			}

			if( Integer.parseInt(checkMinSelectNum) > (i)){
				errors.add("checkAdminText"+(i-1), new ActionMessage("labels.checkMinError"/*"最大選択数は選択肢の数以下にしてください。"*/));
			}

			//必須の場合
			if(StringUtils.equals(inputQuestion.requiredFlg+"", "1") && Integer.parseInt(checkMinSelectNum) == 0 ){
				errors.add("checkAdminText"+(i-1), new ActionMessage("labels.checkMin"/*"必須にチェックを入れた場合最小選択数は1以上を選択してください。"*/));
			}

			if(StringUtils.equals(inputQuestion.requiredFlg+"", "1") && Integer.parseInt(checkMaxSelectNum) == 0 ){
				errors.add("checkAdminText"+(i-1), new ActionMessage("labels.checkMax0"/*"必須にチェックを入れた場合最小選択数は1以上を選択してください。"*/));
			}
			
			if(!StringUtils.equals(inputQuestion.requiredFlg+"", "1") && Integer.parseInt(checkMinSelectNum) > 0 ){
				errors.add("checkAdminText"+(i-1), new ActionMessage("labels.checkMin0"/*"必須にチェックを入れた場合最小選択数は1以上を選択してください。"*/));
			}


			if(StringUtil.equals(checkFreeAnserUse, "1") && Integer.parseInt(checkFreeNo) > i  ){
				errors.add("checkFreeNoError", new ActionMessage("labels.freeMax","該当選択肢"/*"最大選択数は選択肢の数以下にしてください。"*/));
			}

			if(Integer.parseInt(checkMaxSelectNum) <  Integer.parseInt(checkMinSelectNum)){
				errors.add("checkAdminText"+(i-1), new ActionMessage("labels.MinMaxError","最小選択数","最大選択数"));
			}
			
			if(StringUtil.equals(checkMaxSelectNum,"0")){
				errors.add("checkAdminText"+(i-1), new ActionMessage("labels.textMaxLength1up","最大選択数","1以上選択"/*"最大入力文字数を入力してください。"*/));
			}
			

			break;
		case 2:
			/**セレクトメニュー*/
			if(StringUtil.isBlank(selectCand)){
				errors.add("selectCand",new ActionMessage("labels.selectCand"/*"選択候補を入力してください。"*/));
			}else{
				Integer selectLenth = PropertyUtil.getInt("ENQUETE_SELECT_LENGTH");
				String [] selectCands =selectCand.split("\r\n");

				for(int k =0;k< selectCands.length;k++){
					if(selectCands[k].length() > selectLenth){
						errors.add("selectCand",new ActionMessage("enquete.textLimit","選択候補の一行には"+selectLenth));
					}
				}
			}

			/*if(StringUtil.isBlank(selectDefault)){
				errors.add("selectDefault",new ActionMessage("デフォルト値を入力してください。",false));
			}*/

			if(!StringUtil.isBlank(selectDefault) && !StringUtil.isBlank(selectCand)){
				String[] selectCands = selectCand.split("\r\n");
				if (!new ListTool().contains(selectCands, selectDefault)) {
					errors.add("selectDefault", new ActionMessage("labels.defaultSelect"/*"デフォルト値が選択候補にありません。"*/));
				}
			}

			break;
		case 3:
			/**テキストエリア チェックなし*/
			break;
		case 4:
			/**テキストボックス*/
			boolean isCheck = true;
			
			if(StringUtil.isBlank(textMinLength)){
				errors.add("textMinLength", new ActionMessage("labels.textMinLength"/*"最小入力文字数を入力してください。"*/));
			}else if(!textMinLength.matches("^[0-9]{0,5}$")){
				if(StringUtil.isNumber(textMinLength)){
					errors.add("textMinLength", new ActionMessage("labels.textLengthOrver"/*"最小入力文字数が大きすぎます。"*/,"最小入力文字数"));
				}else{
					errors.add("textMinLength", new ActionMessage("labels.textLengthError"/*"最大入力文字数が大きすぎます。"*/,"数字"));
				}
				
				isCheck= false;
			}else if(StringUtil.isNumber(textMinLength) && Integer.parseInt(textMinLength) > Short.MAX_VALUE){
				errors.add("textMinLength", new ActionMessage("labels.textLengthOrver"/*"最大入力文字数が大きすぎます。"*/,"最小入力文字数"));
			}else if(!StringUtils.equals(inputQuestion.requiredFlg+"", "1") && Integer.parseInt(textMinLength) > 0 ){
				errors.add("textMinLength", new ActionMessage("labels.textMin0"/*"必須にチェックを入れてない場合最小選択数は0を入力してください。"*/));
			}

			
			if(StringUtil.equals(textMaxLength,"0")){
				errors.add("textMaxLength", new ActionMessage("labels.textMaxLength1up","最大入力文字数","1以上入力"));
			}if(StringUtil.isBlank(textMaxLength)){
				errors.add("textMaxLength", new ActionMessage("labels.textMaxLength"/*"最大入力文字数を入力してください。"*/));
			}else if(!textMaxLength.matches("^[0-9]{0,5}$")){
				if(StringUtil.isNumber(textMaxLength)){
					errors.add("textMaxLength", new ActionMessage("labels.textLengthOrver"/*"最大入力文字数が大きすぎます。"*/,"最大入力文字数"));
				}else{
					errors.add("textMaxLength", new ActionMessage("labels.textLengthError"/*"最大入力文字数が大きすぎます。"*/,"数字"));
				}
				
				
				isCheck= false;
			}else if(StringUtil.isNumber(textMaxLength) && Integer.parseInt(textMaxLength) > Short.MAX_VALUE){
				errors.add("textMaxLength", new ActionMessage("labels.textLengthOrver"/*"最大入力文字数が大きすぎます。"*/,"最大入力文字数"));
			}//必須の場合
			else if(StringUtils.equals(inputQuestion.requiredFlg+"", "1") && StringUtil.isNotBlank(textMinLength)){
				if(Integer.parseInt(textMinLength) == 0 || Integer.parseInt(textMaxLength) == 0 ){
					errors.add("textMaxLength", new ActionMessage("labels.textMax0"/*必須にチェックを入れた場合最小入力文字数、最大入力文字数には1以上を入力してください。*/));
				}
			}

			if((isCheck && StringUtil.isNotBlank(textMaxLength) && StringUtil.isNotBlank(textMinLength))
					&& ( Integer.parseInt(textMaxLength) < Integer.parseInt(textMinLength)  )
					){
				errors.add("textMaxLength", new ActionMessage("lables.maxMinCheck"/*"最大文字数は最小文字数以下で入力してください。"*/));
			}
			break;
		case 5:
			/**日付入力フォーム*/
			if(StringUtil.isNotBlank(dateFrom) && StringUtil.isNotBlank(dateTo) && dateTo.compareTo(dateFrom) < 0 ){
				errors.add("dateError", new ActionMessage("errors.E020"));
			}else if((StringUtil.isNotBlank(dateFrom) && !SinaburoUtil.checkDate(dateFrom)) || (StringUtil.isNotBlank(dateTo) && !SinaburoUtil.checkDate(dateTo)) ){
				errors.add("dateError", new ActionMessage("errors.E033"));
				errors.add("dateError_1", new ActionMessage("errors.E033_1"));
				errors.add("dateError_2", new ActionMessage("errors.E033_2"));
			}


			break;
		case 6:
			/**1%支援制度ポイント寄付 チェックなし*/
			break;
		}

		return errors;
	}
	public static void main(String[] args) {
		System.out.println(Short.MAX_VALUE);
	}

//	private void radioCheck(ActionMessages error){
//
//	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, StandardToStringStyle.SIMPLE_STYLE).toString();
	}



}
